module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = require('../../../ssr-module-cache.js');
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete installedModules[moduleId];
/******/ 		}
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 6);
/******/ })
/************************************************************************/
/******/ ({

/***/ "4Q3z":
/***/ (function(module, exports) {

module.exports = require("next/router");

/***/ }),

/***/ "5JtJ":
/***/ (function(module, exports) {



/***/ }),

/***/ 6:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("XpG4");


/***/ }),

/***/ "KNus":
/***/ (function(module, exports) {

module.exports = require("next/config");

/***/ }),

/***/ "LG7s":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: external "react"
var external_react_ = __webpack_require__("cDcd");
var external_react_default = /*#__PURE__*/__webpack_require__.n(external_react_);

// EXTERNAL MODULE: external "next/head"
var head_ = __webpack_require__("xnum");
var head_default = /*#__PURE__*/__webpack_require__.n(head_);

// EXTERNAL MODULE: ./components/extensions/collapsible/collapsible.scss
var collapsible = __webpack_require__("R/v/");

// CONCATENATED MODULE: ./components/extensions/collapsible/collapsible.ts

function initCollapsibles(element) {
  element.addEventListener('click', event => {
    const target = event.target;

    if (target && Array.from(target.classList).includes('collapsible__open')) {
      target.parentElement.classList.add('collapsible_opened');
    }

    if (target && Array.from(target.classList).includes('collapsible__close')) {
      target.parentElement.classList.remove('collapsible_opened');
    }
  });
}
// EXTERNAL MODULE: ./components/extensions/tabs/tabs.scss
var tabs = __webpack_require__("5JtJ");

// CONCATENATED MODULE: ./components/extensions/tabs/tabs.ts


function createElementFromHTML(input) {
  var template = document.createElement('template');
  template.innerHTML = input.trim();
  return template.content.firstChild;
}

function generateId() {
  return Math.random().toString(36).substring(2);
}

function prepareTabsElements(rootElement) {
  Array.from(rootElement.querySelectorAll('.tabs')).forEach(element => {
    const idSequence = [];

    const getNextId = () => {
      const id = generateId();
      idSequence.push(id);
      return id;
    };

    const titleElements = Array.from(element.querySelectorAll('.tab__title'));
    const titles = titleElements.map(e => e.innerHTML);
    let titlesHtml = '<div class="tabs__titles">';

    for (let i = 0; i < titles.length; i++) {
      titlesHtml += `<div class="tabs__title${i === 0 ? ' tabs__title_active' : ''}" data-tab-id="${getNextId()}">${titles[i]}</div>`;
    }

    titlesHtml += '</div>';
    const titlesBlock = createElementFromHTML(titlesHtml);
    element.prepend(titlesBlock);
    titleElements.map(e => e.remove());
    Array.from(element.querySelectorAll('.tab')).forEach((tabElement, i) => {
      tabElement.dataset.tabContentId = idSequence[i];

      if (i === 0) {
        tabElement.classList.add('tab_active');
      }
    });
  });
}
function initTabs(element) {
  element.addEventListener('click', event => {
    const target = event.target;

    if (target && Array.from(target.classList).includes('tabs__title')) {
      const tabsRoot = target.parentElement.parentElement;
      const tabId = target.dataset.tabId;
      const oldActiveTab = tabsRoot.querySelector('.tabs__title_active');

      if (oldActiveTab) {
        const oldTabId = oldActiveTab.dataset.tabId;
        tabsRoot.querySelector(`.tabs__title[data-tab-id="${oldTabId}"]`).classList.remove('tabs__title_active');
        tabsRoot.querySelector(`.tab[data-tab-content-id="${oldTabId}"]`).classList.remove('tab_active');
      }

      target.classList.add('tabs__title_active');
      tabsRoot.querySelector(`.tab[data-tab-content-id="${tabId}"]`).classList.add('tab_active');
    }
  });
  prepareTabsElements(element);
}
// CONCATENATED MODULE: ./components/extensions/index.tsx


// EXTERNAL MODULE: ./components/App/App.scss
var App_App = __webpack_require__("V2f5");

// EXTERNAL MODULE: external "next/router"
var router_ = __webpack_require__("4Q3z");

// EXTERNAL MODULE: ./components/App/Header/Header.scss
var Header = __webpack_require__("x7bt");

// EXTERNAL MODULE: ./components/App/context.tsx
var App_context = __webpack_require__("tTZ+");

// CONCATENATED MODULE: ./components/App/Header/Header.tsx
var __jsx = external_react_default.a.createElement;





function renderSignIn(user, pathname) {
  if (user) {
    return __jsx("div", {
      className: "header__top-content header__top-content_right"
    }, __jsx("a", {
      className: "header__link",
      href: "/auth/logout"
    }, "Sign out"));
  }

  return __jsx("div", {
    className: "header__top-content header__top-content_right"
  }, __jsx("a", {
    className: "header__link",
    href: `/auth/google?returnPath=${encodeURIComponent(pathname)}`
  }, "Sign in"));
}

function renderNavigation() {
  return __jsx("div", {
    className: "header__navigation-content"
  }, __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/random",
    className: "header__link"
  }, "Random page")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list",
    className: "header__link"
  }, "Series I")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-2",
    className: "header__link"
  }, "Series II")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-3",
    className: "header__link"
  }, "Series III")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-4",
    className: "header__link"
  }, "Series IV")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-5",
    className: "header__link"
  }, "Series V")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-ru",
    className: "header__link"
  }, "Series RU")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/stories",
    className: "header__link"
  }, "Stories")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/canon-hub",
    className: "header__link"
  }, "Canons")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/drafts",
    className: "header__link"
  }, "Drafts")));
}

const Header_Header = () => {
  const router = Object(router_["useRouter"])();
  const ctx = Object(external_react_["useContext"])(App_context["a" /* default */]);
  return __jsx("header", {
    className: "header"
  }, __jsx("div", {
    className: "header__container"
  }, __jsx("div", {
    className: "header__top-content"
  }, __jsx("a", {
    href: "/",
    className: "header__link"
  }, "SCP Foundation")), renderSignIn(ctx.user, router.asPath)), __jsx("div", {
    className: "header__navigation"
  }, renderNavigation()));
};

/* harmony default export */ var App_Header_Header = (Header_Header);
// EXTERNAL MODULE: ./components/App/Footer/Footer.scss
var Footer = __webpack_require__("i0sC");

// CONCATENATED MODULE: ./components/App/Footer/Footer.tsx
var Footer_jsx = external_react_default.a.createElement;



const Footer_Footer = () => Footer_jsx("footer", {
  className: "footer"
}, "Unless otherwise stated, the content of this page is licensed under ", Footer_jsx("a", {
  href: "https://creativecommons.org/licenses/by-sa/3.0/",
  target: "_blank",
  rel: "noopener noreferrer"
}, "Creative Commons Attribution-ShareAlike 3.0 License"));

/* harmony default export */ var App_Footer_Footer = (Footer_Footer);
// EXTERNAL MODULE: ./utils/sdk.ts
var utils_sdk = __webpack_require__("UfsA");

// CONCATENATED MODULE: ./components/App/App.tsx
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return App_App_App; });
var App_jsx = external_react_default.a.createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }









class App_App_App extends external_react_default.a.Component {
  static async getInitialProps(context) {
    const sdk = new utils_sdk["a" /* default */](context.req ? context.req.headers.cookie : '');

    try {
      const user = await sdk.whoami();
      return {
        user,
        sdk
      };
    } catch (error) {
      console.error('Error fetching user', error && error.response && error.response.data || error);
      throw error;
    }
  }

  componentDidMount() {
    initCollapsibles(document.body);
    initTabs(document.body);
  }

  render() {
    const {
      children
    } = this.props;
    const sdk = new utils_sdk["a" /* default */]();
    const ctx = this.props.context.sdk instanceof utils_sdk["a" /* default */] ? this.props.context : _objectSpread({}, this.props.context, {
      sdk: new utils_sdk["a" /* default */]()
    }); // @ts-ignore

    if (global.window) {
      // @ts-ignore
      global.window.sdk = sdk;
    }

    return App_jsx(App_context["a" /* default */].Provider, {
      value: ctx
    }, App_jsx(head_default.a, null, App_jsx("meta", {
      name: "viewport",
      content: "initial-scale=1.0, width=device-width, minimal-ui"
    })), App_jsx("div", {
      className: "app"
    }, App_jsx("div", {
      className: "app-header"
    }, App_jsx(App_Header_Header, null)), App_jsx("main", {
      className: "app-content"
    }, children, App_jsx("div", {
      className: "app-footer"
    }, App_jsx(App_Footer_Footer, null)))));
  }

}

/***/ }),

/***/ "R/v/":
/***/ (function(module, exports) {



/***/ }),

/***/ "UfsA":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SDK; });
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("zr5I");
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(axios__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var next_config__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("KNus");
/* harmony import */ var next_config__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(next_config__WEBPACK_IMPORTED_MODULE_1__);
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }



const {
  publicRuntimeConfig
} = next_config__WEBPACK_IMPORTED_MODULE_1___default()();
const {
  BROWSER_API_ENDPOINT,
  SERVER_API_ENDPOINT
} = publicRuntimeConfig;
const WIKI_NAME = 'scp-ru';

function getApiEndpoint() {
  if (false) {} else {
    return SERVER_API_ENDPOINT || 'https://m.scpfoundation.net';
  }
}

class SDK {
  constructor(authCookie) {
    _defineProperty(this, "axios", void 0);

    if (true) {
      this.axios = axios__WEBPACK_IMPORTED_MODULE_0___default.a.create({
        headers: {
          cookie: authCookie || ''
        }
      });
    } else {}
  }

  async whoami() {
    const response = await this.axios.get(`${getApiEndpoint()}/auth/whoami`);
    const user = response.data;

    if (user && user.id) {
      return user;
    } else {
      return null;
    }
  }

  get(url) {
    return this.axios.get(`${getApiEndpoint()}${url}`).then(response => response.data);
  }

  post(url, data) {
    return this.axios.post(`${getApiEndpoint()}${url}`, data).then(response => response.data);
  }

  delete(url) {
    return this.axios.delete(`${getApiEndpoint()}${url}`).then(response => response.data);
  }

  async getWikidotPage(pageName) {
    const url = `${getApiEndpoint()}/api/wikidot/pages/${WIKI_NAME}/${pageName.toLowerCase()}`;
    const response = await this.axios.get(url);
    return response.data.page;
  }

  async getRandomWikidotPageName() {
    try {
      const response = await this.axios.get(`${getApiEndpoint()}/api/wikidot_random_page`);
      return response.data.name;
    } catch (error) {
      console.error('Failed to get random page', error);
      throw error;
    }
  }

  async tetherWikidotAccount() {
    try {
      const response = await this.axios.post(`${getApiEndpoint()}/wikidot/api/tether-account`);
      return response.data && response.data.code;
    } catch (error) {
      const response = error.response;

      if (response && response.data && response.data.code) {
        return response.data.code;
      } else {
        throw error;
      }
    }
  }

}

/***/ }),

/***/ "V2f5":
/***/ (function(module, exports) {



/***/ }),

/***/ "XpG4":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("cDcd");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var next_router__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("4Q3z");
/* harmony import */ var next_router__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(next_router__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _components_App_App__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("LG7s");



/* harmony default export */ __webpack_exports__["default"] = (class extends react__WEBPACK_IMPORTED_MODULE_0___default.a.Component {
  static async getInitialProps(pageContext) {
    const appContext = await _components_App_App__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"].getInitialProps(pageContext);
    const sdk = appContext.sdk;
    const res = pageContext.res;
    const pageName = await sdk.getRandomWikidotPageName();

    if (res) {
      res.writeHead(302, {
        Location: pageName
      });
      res.end();
    } else {
      next_router__WEBPACK_IMPORTED_MODULE_1___default.a.push(`/${pageName}`);
    }

    return {};
  }

});

/***/ }),

/***/ "cDcd":
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),

/***/ "i0sC":
/***/ (function(module, exports) {



/***/ }),

/***/ "tTZ+":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("cDcd");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _utils_sdk__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("UfsA");


const AppContext = react__WEBPACK_IMPORTED_MODULE_0___default.a.createContext({
  user: null,
  sdk: new _utils_sdk__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]()
});
/* harmony default export */ __webpack_exports__["a"] = (AppContext);

/***/ }),

/***/ "x7bt":
/***/ (function(module, exports) {



/***/ }),

/***/ "xnum":
/***/ (function(module, exports) {

module.exports = require("next/head");

/***/ }),

/***/ "zr5I":
/***/ (function(module, exports) {

module.exports = require("axios");

/***/ })

/******/ });