module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = require('../../../../ssr-module-cache.js');
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete installedModules[moduleId];
/******/ 		}
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ({

/***/ "/xJA":
/***/ (function(module, exports) {

module.exports = require("markdown-it-footnote");

/***/ }),

/***/ "05WW":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Draft; });
class Draft {
  static async list(ctx) {
    return ctx.sdk.get('/api/drafts');
  }

  static async get(ctx, id) {
    return ctx.sdk.get(`/api/drafts/${id}`);
  }

  static async delete(ctx, id) {
    return await ctx.sdk.delete(`/api/drafts/${id}`);
  }

  static async create(ctx, title, content) {
    return await ctx.sdk.post(`/api/drafts`, {
      title,
      content
    });
  }

  static async update(ctx, id, title, content) {
    return await ctx.sdk.post(`/api/drafts/${id}`, {
      title,
      content
    });
  }

}

/***/ }),

/***/ 1:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("CTij");


/***/ }),

/***/ "2xWL":
/***/ (function(module, exports) {

module.exports = require("markdown-it-anchor");

/***/ }),

/***/ "4Q3z":
/***/ (function(module, exports) {

module.exports = require("next/router");

/***/ }),

/***/ "5JtJ":
/***/ (function(module, exports) {



/***/ }),

/***/ "CTij":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external "react"
var external_react_ = __webpack_require__("cDcd");
var external_react_default = /*#__PURE__*/__webpack_require__.n(external_react_);

// EXTERNAL MODULE: external "next/head"
var head_ = __webpack_require__("xnum");
var head_default = /*#__PURE__*/__webpack_require__.n(head_);

// EXTERNAL MODULE: ./components/App/App.tsx + 5 modules
var App = __webpack_require__("LG7s");

// EXTERNAL MODULE: ./components/Container/Container.tsx
var Container = __webpack_require__("Diez");

// EXTERNAL MODULE: ./components/Draft/DraftView.scss
var DraftView = __webpack_require__("cJco");

// EXTERNAL MODULE: ./components/Page/Page.scss
var Page = __webpack_require__("au+6");

// EXTERNAL MODULE: ./components/App/context.tsx
var context = __webpack_require__("tTZ+");

// CONCATENATED MODULE: ./components/Draft/DraftView.tsx
var __jsx = external_react_default.a.createElement;





const renderEditButton = draftId => __jsx("div", {
  className: "draft__title-actions"
}, __jsx("a", {
  href: `/drafts/${draftId}/edit`,
  className: "button action s"
}, "Edit"));

const DraftView_DraftView = ({
  draft,
  renderedContent
}) => {
  var _ctx$user;

  const ctx = Object(external_react_["useContext"])(context["a" /* default */]);
  return __jsx("div", {
    className: "draft"
  }, __jsx("a", {
    href: "/drafts"
  }, "\u2191 Back to the drafts"), __jsx("div", {
    className: "draft__title"
  }, draft.title, ((_ctx$user = ctx.user) === null || _ctx$user === void 0 ? void 0 : _ctx$user.username) === draft.author && renderEditButton(draft.id)), __jsx("div", {
    className: "page"
  }, __jsx("div", {
    className: "draft__content page__content",
    dangerouslySetInnerHTML: {
      __html: renderedContent
    }
  })));
};

/* harmony default export */ var Draft_DraftView = (DraftView_DraftView);
// EXTERNAL MODULE: ./models/Draft/draft.ts
var Draft_draft = __webpack_require__("05WW");

// EXTERNAL MODULE: ./renderer/index.ts + 6 modules
var renderer = __webpack_require__("Ki4V");

// CONCATENATED MODULE: ./pages/drafts/[draft].tsx
var _draft_jsx = external_react_default.a.createElement;








const DraftContainer = ({
  ctx,
  draft,
  renderedContent
}) => {
  return _draft_jsx(external_react_default.a.Fragment, null, _draft_jsx(head_default.a, null, _draft_jsx("title", null, "Drafts | SCP Foundation")), _draft_jsx(App["a" /* default */], {
    context: ctx
  }, _draft_jsx(Container["a" /* default */], null, _draft_jsx(Draft_DraftView, {
    draft: draft,
    renderedContent: renderedContent
  }))));
};

DraftContainer.getInitialProps = async pageContext => {
  const ctx = await App["a" /* default */].getInitialProps(pageContext);
  const draftId = pageContext.query.draft;
  const draft = await Draft_draft["a" /* Draft */].get(ctx, draftId);
  const renderedContent = Object(renderer["a" /* default */])({
    name: draft.title
  }, draft.content);
  return {
    ctx,
    draft,
    renderedContent
  };
};

/* harmony default export */ var _draft_ = __webpack_exports__["default"] = (DraftContainer);

/***/ }),

/***/ "Diez":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("cDcd");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _Container_scss__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("y1OJ");
/* harmony import */ var _Container_scss__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_Container_scss__WEBPACK_IMPORTED_MODULE_1__);
var __jsx = react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement;



const Container = ({
  children
}) => {
  return __jsx("div", {
    className: "container"
  }, children);
};

/* harmony default export */ __webpack_exports__["a"] = (Container);

/***/ }),

/***/ "KNus":
/***/ (function(module, exports) {

module.exports = require("next/config");

/***/ }),

/***/ "Ki4V":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: external "markdown-it"
var external_markdown_it_ = __webpack_require__("XUTK");
var external_markdown_it_default = /*#__PURE__*/__webpack_require__.n(external_markdown_it_);

// CONCATENATED MODULE: ./renderer/plugins/collapsible.ts
const CloseTypes = {
  top: 'top',
  bottom: 'bottom',
  both: 'both'
};
/* harmony default export */ var collapsible = (function (md) {
  md.core.ruler.push('collapsible', state => {
    const COLLAPSIBLE_OPEN_REGEX = /\[\[collapsible\s*(.*)\s*]]/;
    const COLLAPSIBLE_CLOSE_REGEX = /\[\[\/collapsible]]/;
    const COLLAPSIBLE_OPTION_HIDE = 'hide="';
    const COLLAPSIBLE_OPTION_SHOW = 'show="';
    let closeTexts = []; // for invested collapsible blocks

    let closeTypes = []; // for invested collapsible blocks

    const tokens = state.tokens;
    let i = 0;

    while (i < tokens.length) {
      const openToken = tokens[i];
      const token = tokens[i + 1];
      let matchOpen,
          closeType = CloseTypes.top;

      if (openToken.type === 'paragraph_open' && (matchOpen = token.content.match(COLLAPSIBLE_OPEN_REGEX))) {
        const collapsible = new state.Token('collapsible_open', 'div', 0);
        const collapsibleOptions = matchOpen[1].split(/" /); //Initial values

        collapsible.content = {
          openText: '',
          closeText: '',
          closeType: ''
        };
        collapsibleOptions.forEach(option => {
          if (option.endsWith('"')) {
            option = option.slice(0, -1);
          }

          if (option.startsWith(COLLAPSIBLE_OPTION_HIDE)) {
            collapsible.content.closeText = option.substr(COLLAPSIBLE_OPTION_HIDE.length);
          } else if (option.startsWith(COLLAPSIBLE_OPTION_SHOW)) {
            collapsible.content.openText = option.substr(COLLAPSIBLE_OPTION_SHOW.length);
          } else if (option.startsWith('hideLocation="both')) {
            closeType = CloseTypes.both;
          } else if (option.startsWith('hideLocation="bottom')) {
            closeType = CloseTypes.bottom;
          }
        });
        collapsible.content.closeType = closeType;
        closeTypes.push(closeType);
        closeTexts.push(collapsible.content.closeText);
        tokens.splice(i, 3, collapsible);
      }

      if (openToken.type === 'paragraph_open' && token.content.match(COLLAPSIBLE_CLOSE_REGEX)) {
        const collapsible = new state.Token('collapsible_close', 'div', 0);
        collapsible.content = {
          closeType: closeTypes.pop(),
          closeText: closeTexts.pop()
        };
        tokens.splice(i, 3, collapsible);
      }

      i++;
    }
  });
});
;
// CONCATENATED MODULE: ./renderer/plugins/tabs.ts
/* harmony default export */ var tabs = (function (md) {
  md.core.ruler.push('tabs', state => {
    const TABVIEW_OPEN_REGEX = /\[\[tabview]]/;
    const TABVIEW_CLOSE_REGEX = /\[\[\/tabview]]/;
    const TAB_OPEN_REGEX = /\[\[tab\stitle="(.*)"]]/;
    const TAB_OPEN_REGEX_2 = /\[\[tab\s(.*)]]/;
    const TAB_CLOSE_REGEX = /\[\[\/tab]]/;
    const tokens = state.tokens;
    let i = 0;

    while (i < tokens.length - 1) {
      const openToken = tokens[i];
      const token = tokens[i + 1];
      let match; // <Open>

      if (openToken.type === 'paragraph_open' && token.content.match(TABVIEW_OPEN_REGEX)) {
        const tabviewOpen = new state.Token('tabview_open', 'div', 0);
        tokens.splice(i, 3, tabviewOpen);
      }

      if (openToken.type === 'paragraph_open' && (match = token.content.match(TAB_OPEN_REGEX) || token.content.match(TAB_OPEN_REGEX_2))) {
        const tabOpen = new state.Token('tab_open', 'div', 0);
        tabOpen.content = match[1];
        tokens.splice(i, 3, tabOpen);
      } // <Close>


      if (openToken.type === 'paragraph_open' && token.content.match(TABVIEW_CLOSE_REGEX)) {
        const tabviewClose = new state.Token('tabview_close', 'div', 0);
        tokens.splice(i, 3, tabviewClose);
      }

      if (openToken.type === 'paragraph_open' && token.content.match(TAB_CLOSE_REGEX)) {
        const tabClose = new state.Token('tab_close', 'div', 0);
        tokens.splice(i, 3, tabClose);
      }

      i++;
    }
  });
});
;
// CONCATENATED MODULE: ./renderer/markdown.ts




const anchorModule = __webpack_require__("2xWL");

const md = external_markdown_it_default()({
  breaks: true
}).use(__webpack_require__("t28V")).use(__webpack_require__("TVgv")).use(__webpack_require__("/xJA")).use(__webpack_require__("sdgC")).use(__webpack_require__("UxWH")).use(anchorModule.default || anchorModule).use(__webpack_require__("wqGw")).use(__webpack_require__("Wsky"), 'image-right').use(__webpack_require__("Wsky"), 'align-center').use(collapsible).use(tabs);
function renderMarkdown(meta, content) {
  md.renderer.rules.table_open = () => '<div class="table"><table>';

  md.renderer.rules.table_close = () => '</table></div>';

  md.renderer.rules.collapsible_close = (tokens, index) => {
    const content = tokens[index].content;
    return content.closeType === CloseTypes.top ? '</div></div>' : `</div><div class="collapsible__close">${content.closeText}</div></div>`;
  };

  md.renderer.rules.collapsible_open = (tokens, index) => {
    const content = tokens[index].content;
    const closeType = content.closeType;
    let collapsibleBlock = `<div class="collapsible"><div class="collapsible__open">${content.openText}</div>`;

    if (closeType === CloseTypes.top || closeType === CloseTypes.both) {
      collapsibleBlock += `<div class="collapsible__close">${content.closeText}</div>`;
    }

    return collapsibleBlock + '<div class="collapsible__content">';
  };

  md.renderer.rules.tabview_open = () => '<div class="tabs">';

  md.renderer.rules.tabview_close = () => '</div>';

  md.renderer.rules.tab_close = () => '</div></div>';

  md.renderer.rules.tab_open = (tokens, index) => {
    const title = tokens[index].content;
    return `<div class="tab"><div class="tab__title">${title}</div><div class="tab__content">`;
  };

  return md.render(content);
}
// CONCATENATED MODULE: ./renderer/plugins/table.ts
const SEPARATOR = '---|';

function getTableHead(cells) {
  // String after tableHead
  let headSeparator = '\n|' + SEPARATOR.repeat(cells.length + 1) + '\n';
  let head = '|',
      firstRow = '';

  if (cells[0].startsWith('~')) {
    cells.forEach(cell => {
      head += cell.replace(/~\s/, '') + '|';
    });
  } else {
    head = head.repeat(cells.length + 1);
    firstRow = cells.reduce((prevCells, cell) => prevCells += `${cell}|`, '|') + '\n';
  }

  return '\n' + head + headSeparator + firstRow;
}

function prepareTableRow(row, isFirst = false) {
  const cells = row.substring(2, row.lastIndexOf('||')).split('||');

  if (isFirst) {
    return getTableHead(cells);
  }

  return cells.reduce((prevCells, cell) => prevCells += `${cell}|`, '|') + '\n';
}

function isNextRowTable(row) {
  return row.startsWith('||');
}

/* harmony default export */ var table = (function (input) {
  const rows = input.split('\n');
  let preparedContent = '';
  let inTable = false;
  rows.forEach((row, index) => {
    if (inTable) {
      preparedContent += prepareTableRow(row);
      inTable = rows[index + 1] ? isNextRowTable(rows[index + 1]) : false;
    } else if (row.startsWith('||')) {
      preparedContent += prepareTableRow(row, true);
      inTable = rows[index + 1] ? isNextRowTable(rows[index + 1]) : false;
    } else {
      preparedContent += row + '\n';
    }
  });
  return preparedContent;
});
// CONCATENATED MODULE: ./renderer/preprocess.ts

const imgBlockRegex = /\[\[include component:image-block\s+name=(.+?)\s*\|\s*caption=(.*?)\]\]/sgi;
const imgRightRegex = /\[\[div class="rimg"]]\s*\[\[image\s+(.+?)\s+width="(\d+?)"\s?]]\s*\[\[span]](.+?)\[\[\/span]]\s*\[\[\/div]]/sgi;
const imgCenterRegex = /\[\[div class="cimg"]]\s*\[\[image\s+(.+?)\s+width="(\d+?)"\s?]]\s*\[\[span]](.+?)\[\[\/span]]\s*\[\[\/div]]/sgi;
const imgLeftRegex = /\[\[div class="limg"]]\s*\[\[image\s+(.+?)\s+width="(\d+?)"\s?]]\s*\[\[span]](.+?)\[\[\/span]]\s*\[\[\/div]]/sgi;
const imgLinkedRightRegex = /\[\[div class="rimg"]]\s*\[\[image\s+(.+?)\s+link=".+?"\s+width="(\d+?)"\s?]]\s*\[\[span]](.+?)\[\[\/span]]\s*\[\[\/div]]/gi;
function preprocess(meta, input) {
  const parsedInput = input // Vote blocks
  .replace(/\[\[>]]\n\[\[module\sRate]]\n\[\[\/>]]/gi, '') // CSS blocks
  .replace(/\[\[module\sCSS]](.*?)\[\[\/module]]/sgi, '').replace(/\[\[module\sCountPages.+?]](.*?)\[\[\/module]]/sgi, '') // Wiki links with title [[scp-173 | The Sculpture]]
  .replace(/\[\[\[(.+?)\s*\|(.+?)]]]/gi, '[$2](./$1)') // Wiki links without title [[SCP-173]]
  .replace(/\[\[\[([a-z_0-9#-]+)]]]/gi, '[$1](./$1)') // Italic
  .replace(/\/\/(.*?)\/\//gi, '*$1*') // Colored text
  .replace(/##(\w+?)\|(.+?)##/g, '[[colored-text $1|$2]]') // HR
  .replace(/\n-+[\n$]/g, '\n\n----\n\n') // Strike
  .replace(/--(.+?)--/gi, '~~$1~~') // Footnotes
  .replace(/\[\[footnote]](.+?)\[\[\/footnote]]/gi, '^[$1]') // Monospace
  .replace(/{{(.+?)}}/gi, '`$1`') // Numbered lists
  .replace(/^# /mgi, '1. ') // Headers
  .replace(/^\+ /mgi, '# ').replace(/^\+\+ /mgi, '## ').replace(/^\+\+\+ /mgi, '### ').replace(/^\+\+\+\+ /mgi, '#### ').replace(/^\+\+\+\+\+ /mgi, '##### ').replace(/^\+\+\+\+\+\+ /mgi, '###### ') // Collapsible
  .replace(/\[\[(\/)?collapsible(.*)?]]/gi, '\n[[$1collapsible$2]]\n') // Tabs
  .replace(/\[\[(\/)?tab(view)?]]/gi, '\n[[$1tab$2]]\n') // Code block [[code]] & [[/code]]
  .replace(/\n\[\[(\/)?code]]\n/gi, '\n```\n').replace(imgBlockRegex, `::: image-right\n![$2]($1)\n$2\n:::`).replace(imgLinkedRightRegex, `::: image-right\n![$3]($1)\n$3\n:::`).replace(imgRightRegex, `::: image-right\n![$3]($1)\n$3\n:::`).replace(imgCenterRegex, `::: image-center\n![$3]($1)\n$3\n:::`).replace(imgLeftRegex, `::: image-left\n![$3]($1)\n$3\n:::`) // Simple inline images
  .replace(/\[\[=?image (.*?) style="(.*?)"]]/g, '![$1](./$1)').replace(/\[\[=?image (.*?)]]/g, '![$1](./$1)') // Blank lines
  .replace(/@@@@\n/g, '<br />') // Center align
  .replace(/\[\[==]](.*?)\[\[\/==]]/sg, ':::align-center\n$1\n:::\n') // Dialogs
  .replace(/^-\s/mg, '— '); // console.log(parsedIsnput)
  // Plugin for parsing tables

  return table(parsedInput);
}
// CONCATENATED MODULE: ./renderer/postprocess.ts
const linkTag = '<a class="link" href="$1">$2</a>';
const imgSrcRegex = /<img src="(?!http)/g;
const documentLinkRegex = /\[\[\[(document-.*)\s*\|(.*)]]]/g;
function postprocess(meta, input) {
  const imgSrc = `<img src="https://scp.storage.yandexcloud.net/wikidot/scp-ru/${meta.name.toLowerCase()}/`;
  return input.replace(/\s*_<br>\s*/g, ' ') // Colored text (from preprocess)
  .replace(/\[\[colored-text\s(\w+?)\|(.+?)]]/g, '<span class="colored-text colored-text_$1">$2</span>') // Center text
  .replace(/\[\[=]](.*?)\[\[\/=]]/smg, '<div class="aligned-text aligned-text_center">$1</div>').replace(imgSrcRegex, imgSrc).replace(documentLinkRegex, linkTag) // Mdash - вызывает проблемы в урлах до картинок
  // .replace(/[^-]--[^-]/g, ' &mdash; ')
  .replace(/\[\[size (.*?)]](.*?)\[\[\/size]]/g, '<font size="$1">$2</font>') // Styled blocks
  .replace(/\[\[div style=&quot;.*?&quot;]](.*?)\[\[\/div]]/smg, '$1').replace(/\[\[div class=&quot;.*?&quot;]]/g, '').replace(/\[\[\/div]]/g, '').replace(/\[\[span style=&quot;.*?&quot;]](.*?)\[\[\/span]]/smg, '$1');
}
// CONCATENATED MODULE: ./renderer/index.ts
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });



function render(meta, source = '') {
  const preprocessed = preprocess(meta, source);
  const rendered = renderMarkdown(meta, preprocessed);
  const postprocessed = postprocess(meta, rendered);
  return postprocessed;
}

/***/ }),

/***/ "LG7s":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXTERNAL MODULE: external "react"
var external_react_ = __webpack_require__("cDcd");
var external_react_default = /*#__PURE__*/__webpack_require__.n(external_react_);

// EXTERNAL MODULE: external "next/head"
var head_ = __webpack_require__("xnum");
var head_default = /*#__PURE__*/__webpack_require__.n(head_);

// EXTERNAL MODULE: ./components/extensions/collapsible/collapsible.scss
var collapsible = __webpack_require__("R/v/");

// CONCATENATED MODULE: ./components/extensions/collapsible/collapsible.ts

function initCollapsibles(element) {
  element.addEventListener('click', event => {
    const target = event.target;

    if (target && Array.from(target.classList).includes('collapsible__open')) {
      target.parentElement.classList.add('collapsible_opened');
    }

    if (target && Array.from(target.classList).includes('collapsible__close')) {
      target.parentElement.classList.remove('collapsible_opened');
    }
  });
}
// EXTERNAL MODULE: ./components/extensions/tabs/tabs.scss
var tabs = __webpack_require__("5JtJ");

// CONCATENATED MODULE: ./components/extensions/tabs/tabs.ts


function createElementFromHTML(input) {
  var template = document.createElement('template');
  template.innerHTML = input.trim();
  return template.content.firstChild;
}

function generateId() {
  return Math.random().toString(36).substring(2);
}

function prepareTabsElements(rootElement) {
  Array.from(rootElement.querySelectorAll('.tabs')).forEach(element => {
    const idSequence = [];

    const getNextId = () => {
      const id = generateId();
      idSequence.push(id);
      return id;
    };

    const titleElements = Array.from(element.querySelectorAll('.tab__title'));
    const titles = titleElements.map(e => e.innerHTML);
    let titlesHtml = '<div class="tabs__titles">';

    for (let i = 0; i < titles.length; i++) {
      titlesHtml += `<div class="tabs__title${i === 0 ? ' tabs__title_active' : ''}" data-tab-id="${getNextId()}">${titles[i]}</div>`;
    }

    titlesHtml += '</div>';
    const titlesBlock = createElementFromHTML(titlesHtml);
    element.prepend(titlesBlock);
    titleElements.map(e => e.remove());
    Array.from(element.querySelectorAll('.tab')).forEach((tabElement, i) => {
      tabElement.dataset.tabContentId = idSequence[i];

      if (i === 0) {
        tabElement.classList.add('tab_active');
      }
    });
  });
}
function initTabs(element) {
  element.addEventListener('click', event => {
    const target = event.target;

    if (target && Array.from(target.classList).includes('tabs__title')) {
      const tabsRoot = target.parentElement.parentElement;
      const tabId = target.dataset.tabId;
      const oldActiveTab = tabsRoot.querySelector('.tabs__title_active');

      if (oldActiveTab) {
        const oldTabId = oldActiveTab.dataset.tabId;
        tabsRoot.querySelector(`.tabs__title[data-tab-id="${oldTabId}"]`).classList.remove('tabs__title_active');
        tabsRoot.querySelector(`.tab[data-tab-content-id="${oldTabId}"]`).classList.remove('tab_active');
      }

      target.classList.add('tabs__title_active');
      tabsRoot.querySelector(`.tab[data-tab-content-id="${tabId}"]`).classList.add('tab_active');
    }
  });
  prepareTabsElements(element);
}
// CONCATENATED MODULE: ./components/extensions/index.tsx


// EXTERNAL MODULE: ./components/App/App.scss
var App_App = __webpack_require__("V2f5");

// EXTERNAL MODULE: external "next/router"
var router_ = __webpack_require__("4Q3z");

// EXTERNAL MODULE: ./components/App/Header/Header.scss
var Header = __webpack_require__("x7bt");

// EXTERNAL MODULE: ./components/App/context.tsx
var App_context = __webpack_require__("tTZ+");

// CONCATENATED MODULE: ./components/App/Header/Header.tsx
var __jsx = external_react_default.a.createElement;





function renderSignIn(user, pathname) {
  if (user) {
    return __jsx("div", {
      className: "header__top-content header__top-content_right"
    }, __jsx("a", {
      className: "header__link",
      href: "/auth/logout"
    }, "Sign out"));
  }

  return __jsx("div", {
    className: "header__top-content header__top-content_right"
  }, __jsx("a", {
    className: "header__link",
    href: `/auth/google?returnPath=${encodeURIComponent(pathname)}`
  }, "Sign in"));
}

function renderNavigation() {
  return __jsx("div", {
    className: "header__navigation-content"
  }, __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/random",
    className: "header__link"
  }, "Random page")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list",
    className: "header__link"
  }, "Series I")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-2",
    className: "header__link"
  }, "Series II")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-3",
    className: "header__link"
  }, "Series III")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-4",
    className: "header__link"
  }, "Series IV")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-5",
    className: "header__link"
  }, "Series V")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/scp-list-ru",
    className: "header__link"
  }, "Series RU")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/stories",
    className: "header__link"
  }, "Stories")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/canon-hub",
    className: "header__link"
  }, "Canons")), __jsx("span", {
    className: "header__navigation-element"
  }, __jsx("a", {
    href: "/drafts",
    className: "header__link"
  }, "Drafts")));
}

const Header_Header = () => {
  const router = Object(router_["useRouter"])();
  const ctx = Object(external_react_["useContext"])(App_context["a" /* default */]);
  return __jsx("header", {
    className: "header"
  }, __jsx("div", {
    className: "header__container"
  }, __jsx("div", {
    className: "header__top-content"
  }, __jsx("a", {
    href: "/",
    className: "header__link"
  }, "SCP Foundation")), renderSignIn(ctx.user, router.asPath)), __jsx("div", {
    className: "header__navigation"
  }, renderNavigation()));
};

/* harmony default export */ var App_Header_Header = (Header_Header);
// EXTERNAL MODULE: ./components/App/Footer/Footer.scss
var Footer = __webpack_require__("i0sC");

// CONCATENATED MODULE: ./components/App/Footer/Footer.tsx
var Footer_jsx = external_react_default.a.createElement;



const Footer_Footer = () => Footer_jsx("footer", {
  className: "footer"
}, "Unless otherwise stated, the content of this page is licensed under ", Footer_jsx("a", {
  href: "https://creativecommons.org/licenses/by-sa/3.0/",
  target: "_blank",
  rel: "noopener noreferrer"
}, "Creative Commons Attribution-ShareAlike 3.0 License"));

/* harmony default export */ var App_Footer_Footer = (Footer_Footer);
// EXTERNAL MODULE: ./utils/sdk.ts
var utils_sdk = __webpack_require__("UfsA");

// CONCATENATED MODULE: ./components/App/App.tsx
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return App_App_App; });
var App_jsx = external_react_default.a.createElement;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }









class App_App_App extends external_react_default.a.Component {
  static async getInitialProps(context) {
    const sdk = new utils_sdk["a" /* default */](context.req ? context.req.headers.cookie : '');

    try {
      const user = await sdk.whoami();
      return {
        user,
        sdk
      };
    } catch (error) {
      console.error('Error fetching user', error && error.response && error.response.data || error);
      throw error;
    }
  }

  componentDidMount() {
    initCollapsibles(document.body);
    initTabs(document.body);
  }

  render() {
    const {
      children
    } = this.props;
    const sdk = new utils_sdk["a" /* default */]();
    const ctx = this.props.context.sdk instanceof utils_sdk["a" /* default */] ? this.props.context : _objectSpread({}, this.props.context, {
      sdk: new utils_sdk["a" /* default */]()
    }); // @ts-ignore

    if (global.window) {
      // @ts-ignore
      global.window.sdk = sdk;
    }

    return App_jsx(App_context["a" /* default */].Provider, {
      value: ctx
    }, App_jsx(head_default.a, null, App_jsx("meta", {
      name: "viewport",
      content: "initial-scale=1.0, width=device-width, minimal-ui"
    })), App_jsx("div", {
      className: "app"
    }, App_jsx("div", {
      className: "app-header"
    }, App_jsx(App_Header_Header, null)), App_jsx("main", {
      className: "app-content"
    }, children, App_jsx("div", {
      className: "app-footer"
    }, App_jsx(App_Footer_Footer, null)))));
  }

}

/***/ }),

/***/ "R/v/":
/***/ (function(module, exports) {



/***/ }),

/***/ "TVgv":
/***/ (function(module, exports) {

module.exports = require("markdown-it-sup");

/***/ }),

/***/ "UfsA":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SDK; });
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("zr5I");
/* harmony import */ var axios__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(axios__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var next_config__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("KNus");
/* harmony import */ var next_config__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(next_config__WEBPACK_IMPORTED_MODULE_1__);
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }



const {
  publicRuntimeConfig
} = next_config__WEBPACK_IMPORTED_MODULE_1___default()();
const {
  BROWSER_API_ENDPOINT,
  SERVER_API_ENDPOINT
} = publicRuntimeConfig;
const WIKI_NAME = 'scp-ru';

function getApiEndpoint() {
  if (false) {} else {
    return SERVER_API_ENDPOINT || 'https://m.scpfoundation.net';
  }
}

class SDK {
  constructor(authCookie) {
    _defineProperty(this, "axios", void 0);

    if (true) {
      this.axios = axios__WEBPACK_IMPORTED_MODULE_0___default.a.create({
        headers: {
          cookie: authCookie || ''
        }
      });
    } else {}
  }

  async whoami() {
    const response = await this.axios.get(`${getApiEndpoint()}/auth/whoami`);
    const user = response.data;

    if (user && user.id) {
      return user;
    } else {
      return null;
    }
  }

  get(url) {
    return this.axios.get(`${getApiEndpoint()}${url}`).then(response => response.data);
  }

  post(url, data) {
    return this.axios.post(`${getApiEndpoint()}${url}`, data).then(response => response.data);
  }

  delete(url) {
    return this.axios.delete(`${getApiEndpoint()}${url}`).then(response => response.data);
  }

  async getWikidotPage(pageName) {
    const url = `${getApiEndpoint()}/api/wikidot/pages/${WIKI_NAME}/${pageName.toLowerCase()}`;
    const response = await this.axios.get(url);
    return response.data.page;
  }

  async getRandomWikidotPageName() {
    try {
      const response = await this.axios.get(`${getApiEndpoint()}/api/wikidot_random_page`);
      return response.data.name;
    } catch (error) {
      console.error('Failed to get random page', error);
      throw error;
    }
  }

  async tetherWikidotAccount() {
    try {
      const response = await this.axios.post(`${getApiEndpoint()}/wikidot/api/tether-account`);
      return response.data && response.data.code;
    } catch (error) {
      const response = error.response;

      if (response && response.data && response.data.code) {
        return response.data.code;
      } else {
        throw error;
      }
    }
  }

}

/***/ }),

/***/ "UxWH":
/***/ (function(module, exports) {

module.exports = require("markdown-it-abbr");

/***/ }),

/***/ "V2f5":
/***/ (function(module, exports) {



/***/ }),

/***/ "Wsky":
/***/ (function(module, exports) {

module.exports = require("markdown-it-container");

/***/ }),

/***/ "XUTK":
/***/ (function(module, exports) {

module.exports = require("markdown-it");

/***/ }),

/***/ "au+6":
/***/ (function(module, exports) {



/***/ }),

/***/ "cDcd":
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),

/***/ "cJco":
/***/ (function(module, exports) {



/***/ }),

/***/ "i0sC":
/***/ (function(module, exports) {



/***/ }),

/***/ "sdgC":
/***/ (function(module, exports) {

module.exports = require("markdown-it-deflist");

/***/ }),

/***/ "t28V":
/***/ (function(module, exports) {

module.exports = require("markdown-it-sub");

/***/ }),

/***/ "tTZ+":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("cDcd");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _utils_sdk__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("UfsA");


const AppContext = react__WEBPACK_IMPORTED_MODULE_0___default.a.createContext({
  user: null,
  sdk: new _utils_sdk__WEBPACK_IMPORTED_MODULE_1__[/* default */ "a"]()
});
/* harmony default export */ __webpack_exports__["a"] = (AppContext);

/***/ }),

/***/ "wqGw":
/***/ (function(module, exports) {

module.exports = require("markdown-it-table-of-contents");

/***/ }),

/***/ "x7bt":
/***/ (function(module, exports) {



/***/ }),

/***/ "xnum":
/***/ (function(module, exports) {

module.exports = require("next/head");

/***/ }),

/***/ "y1OJ":
/***/ (function(module, exports) {



/***/ }),

/***/ "zr5I":
/***/ (function(module, exports) {

module.exports = require("axios");

/***/ })

/******/ });